package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Button;
import org.zkoss.zul.Messagebox;

import com.rjconsultores.ventaboletos.entidad.ConferenciaPendencia;
import com.rjconsultores.ventaboletos.service.ConferenciaPendenciaService;
import com.rjconsultores.ventaboletos.utilerias.RegistroConDependenciaException;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;

@Controller("editarTipoConfPendComissaoController")
@Scope("prototype")
public class EditarTipoConfPendComissaoController extends MyGenericForwardComposer {
	private static final long serialVersionUID = 1L;
	private ConferenciaPendencia conferenciaPendencia;
	private MyListbox confPendenciaList;
	private MyTextbox txtDescTipoPendComissao;

	@Autowired
	private ConferenciaPendenciaService conferenciaPendService;

	private Button btnApagar;

	@Override
	public void doAfterCompose(Component comp) throws Exception {

		super.doAfterCompose(comp);
		confPendenciaList = (MyListbox) Executions.getCurrent().getArg().get("listBoxConfPendComissao");
		conferenciaPendencia = (ConferenciaPendencia) Executions.getCurrent().getArg().get("confPendComissao");

		if (conferenciaPendencia.getConferenciapendenciaId() == null) {
			btnApagar.setVisible(false);
		} else {
			txtDescTipoPendComissao.setText(conferenciaPendencia.getDescpendencia());
		}
	}

	public void onClick$btnSalvar() {
		if (conferenciaPendencia.getConferenciapendenciaId() != null) {
			confPendenciaList.removeItem(conferenciaPendencia);
		}
		conferenciaPendencia.setActivo(true);
		conferenciaPendencia.setDescpendencia(txtDescTipoPendComissao.getText().toUpperCase());
		conferenciaPendService.suscribir(conferenciaPendencia);
		confPendenciaList.addItemNovo(conferenciaPendencia);

		try {
			Messagebox.show(Labels.getLabel("editarTipoConfPendComissaoController.MSG.salvaOk"),
					Labels.getLabel("editarTipoConfPendComissao.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
		} catch (InterruptedException e) {
			Clients.alert(Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarTipoConfPendComissao.window.title"), Messagebox.INFORMATION);
		}
		closeWindow();
	}

	public void onClick$btnApagar() {

		try {
			int resp = Messagebox.show(Labels.getLabel("editarCatalogoDeRutaController.MSG.borrarPergunta"),
					Labels.getLabel("editarTipoConfPendComissao.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {
				conferenciaPendencia.setActivo(false);
				conferenciaPendService.suscribir(conferenciaPendencia);
				confPendenciaList.removeItem(conferenciaPendencia);

				Messagebox.show(Labels.getLabel("editarTipoConfPendComissaoController.MSG.borrarOK"),
						Labels.getLabel("editarTipoConfPendComissao.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				closeWindow();
			}
		} catch (InterruptedException e) {
			Clients.alert(Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarTipoConfPendComissao.window.title"), Messagebox.INFORMATION);
		}
	}

}
